 
// Credits for the random number generator being used:
// The Central Randomizer 1.3 (C) 1997 by Paul Houle (houle@msc.cornell.edu)
// See:  http://www.msc.cornell.edu/~houle/javascript/randomizer.html

	rnd.today     = new Date();
	rnd.seed      = rnd.today.getTime();
	var gameOver  = false;
	var drawTurn  = false;
	var card1Kept = false;
	var card2Kept = false;
	var card3Kept = false;
	var card4Kept = false;
	var card5Kept = false;

	var face = new Array( "A", "2", "3", "4", "5", "6", "7", "8", "9", "0", "J", "Q", "K");
	var suit = new Array( "s", "h", "c", "d");

	var faceIndex = 0;

	var deckofCards = new Array(52);
	var shuffledCards = new Array(52);
	var dealtHand = new Array(5);

	var cardIndex = 0;

	var cardPrefix = "Resources/cards/";
	var cardSuffix = ".png";

	var blankCardPicture = "Resources/blankCard.png";
	var aceOfSpades = "Resources/cards/As.png";
	var kingOfSpades = "Resources/cards/Ks.png";
	var queenOfSpades = "Resources/cards/Qs.png";
	var jackOfSpades = "Resources/cards/Js.png";
	var tenOfSpades = "Resources/cards/0s.png";
	var nineOfSpades = "Resources/cards/9s.png";
	var eightOfSpades = "Resources/cards/8s.png";
	var sevenOfSpades = "Resources/cards/7s.png";
	var sixOfSpades = "Resources/cards/6s.png";
	var fiveOfSpades = "Resources/cards/5s.png";
	var fourOfSpades = "Resources/cards/4s.png";
	var threeOfSpades = "Resources/cards/3s.png";
	var twoOfSpades = "Resources/cards/2s.png";
	var aceOfHearts = "Resources/cards/Ah.png";
	var kingOfHearts = "Resources/cards/Kh.png";
	var queenOfHearts = "Resources/cards/Qh.png";
	var jackOfHearts = "Resources/cards/Jh.png";
	var tenOfHearts = "Resources/cards/0h.png";
	var nineOfHearts = "Resources/cards/9h.png";
	var eightOfHearts = "Resources/cards/8h.png";
	var sevenOfHearts = "Resources/cards/7h.png";
	var sixOfHearts = "Resources/cards/6h.png";
	var fiveOfHearts = "Resources/cards/5h.png";
	var fourOfHearts = "Resources/cards/4h.png";
	var threeOfHearts = "Resources/cards/3h.png";
	var twoOfHearts = "Resources/cards/2h.png";
	var aceOfClubs = "Resources/cards/Ac.png";
	var kingOfClubs = "Resources/cards/Kc.png";
	var queenOfClubs = "Resources/cards/Qc.png";
	var jackOfClubs = "Resources/cards/Jc.png";
	var tenOfClubs = "Resources/cards/0c.png";
	var nineOfClubs = "Resources/cards/9c.png";
	var eightOfClubs = "Resources/cards/8c.png";
	var sevenOfClubs = "Resources/cards/7c.png";
	var sixOfClubs = "Resources/cards/6c.png";
	var fiveOfClubs = "Resources/cards/5c.png";
	var fourOfClubs = "Resources/cards/4c.png";
	var threeOfClubs = "Resources/cards/3c.png";
	var twoOfClubs = "Resources/cards/2c.png";
	var aceOfDiamonds = "Resources/cards/Ad.png";
	var kingOfDiamonds = "Resources/cards/Kd.png";
	var queenOfDiamonds = "Resources/cards/Qd.png";
	var jackOfDiamonds = "Resources/cards/Jd.png";
	var tenOfDiamonds = "Resources/cards/0d.png";
	var nineOfDiamonds = "Resources/cards/9d.png";
	var eightOfDiamonds = "Resources/cards/8d.png";
	var sevenOfDiamonds = "Resources/cards/7d.png";
	var sixOfDiamonds = "Resources/cards/6d.png";
	var fiveOfDiamonds = "Resources/cards/5d.png";
	var fourOfDiamonds = "Resources/cards/4d.png";
	var threeOfDiamonds = "Resources/cards/3d.png";
	var twoOfDiamonds = "Resources/cards/2d.png";

	var numAce  = 0;
	var numTwo  = 0;
	var numThree  = 0;
	var numFour  = 0;
	var numFive  = 0;
	var numSix  = 0;
	var numSeven  = 0;
	var numEight  = 0;
	var numNine  = 0;
	var numTen = 0;
	var numJack  = 0;
	var numQueen  = 0;
	var numKing  = 0;

	var numSpades   = 0;
	var numHearts   = 0;
	var numClubs    = 0;
	var numDiamonds = 0;

	var numPair          = 0;
	var numTwoPair       = 0;
	var numThreeofaKind  = 0;
	var numStraight      = 0;
	var numFlush         = 0;
	var numFullHouse     = 0;
	var numFourofaKind   = 0;
	var numStraightFlush = 0;
	var numRoyalFlush    = 0;

	var gameScoreNumeric = 100;
	gameScore.data = gameScoreNumeric;

	//Begin Randomizing functions
	function rnd() {
		rnd.seed = (rnd.seed*9301+49297) % 233280;
		return rnd.seed/(233280.0);
	}

	function rand(number) {
		return Math.ceil(rnd()*number);
	}
	//end of Randomizing functions

	function initializeDeck(){
		if ( !drawTurn ) {
			if ( !gameOver ) {
				cardIndex = 0;
				cardPic1.src = blankCardPicture;
				cardPic2.src = blankCardPicture;
				cardPic3.src = blankCardPicture;
				cardPic4.src = blankCardPicture;
				cardPic5.src = blankCardPicture;
				holdCard1.data = "";
				holdCard2.data = "";
				holdCard3.data = "";
				holdCard4.data = "";
				holdCard5.data = "";
				card1Kept = false;
				card2Kept = false;
				card3Kept = false;
				card4Kept = false;
				card5Kept = false;

				for ( i = 0; i < deckofCards.length; i++ ) {
					deckofCards[i] = new Array(2);	
				}

				for ( i = 0; i < suit.length; i++ ) {
					for ( j = 0; j < face.length; j++ ) {
						deckofCards[cardIndex][0] = face[j];
						deckofCards[cardIndex][1] = suit[i];
						cardIndex++;
					}
				}

				for ( i = 0; i < shuffledCards.length; i++ ) {
					shuffledCards[i] = new Array(2);
					shuffledCards[i][0] = " ";
					shuffledCards[i][1] = " ";
				}
				cardIndex = 0;
				displayLine.data = "Discard";
				gameScoreNumeric = gameScoreNumeric - 5;
				gameScore.data = gameScoreNumeric;
				shuffleDeck();
				drawTurn = true;
				displayLine.data = "Hold Cards-Click to deal";
			}else{
				gameIsOver();
			}
		}else{
			deal5Cards();
			checkHand(); //check for any winning hand
			displayLine.data = "Deal";
			drawTurn = false;
			holdCard1.data = "";
			holdCard2.data = "";
			holdCard3.data = "";
			holdCard4.data = "";
			holdCard5.data = "";
			checkGameOver();
			if ( gameOver )
				gameIsOver();

		}//end of "if ( !drawTurn )"
	}//end of initializeDeck


	function checkGameOver() {
		if ( gameScore.data == 0 )
			gameOver = true;
	}//end of checkGameOver


	function gameIsOver() {
		displayLine.data = "";
		winnerLine.data = "";
		gameOverMessage.data = "Game Over";
		resetButton.data = "Play again?";
		drawTurn = false;
	}//end of gameIsOver


	function restartGame() {
		displayLine.data = "Deal";
		gameScoreNumeric = 100;
		gameScore.data = gameScoreNumeric;
		gameOverMessage.data = "";
		resetButton.data = "";
		gameOver     = false;
		cardPic1.src = blankCardPicture;
		cardPic2.src = blankCardPicture;
		cardPic3.src = blankCardPicture;
		cardPic4.src = blankCardPicture;
		cardPic5.src = blankCardPicture;
		card1Kept    = false;
		card2Kept    = false;
		card3Kept    = false;
		card4Kept    = false;
		card5Kept    = false;
		holdCard1.data = "";
		holdCard2.data = "";
		holdCard3.data = "";
		holdCard4.data = "";
		holdCard5.data = "";
	}//end of restartGame


	function shuffleDeck(){

		winnerLine.data = "";

		for ( i = 0; i < deckofCards.length; i++) {

			sRandom = rand(52) -1;
			if ( shuffledCards[sRandom][0] == " " ) {
				shuffledCards[sRandom][0] = deckofCards[i][0];
				shuffledCards[sRandom][1] = deckofCards[i][1];
			}else{
				sRandom = rand(52) -1;
				while ( shuffledCards[sRandom][0] != " " ) {
					sRandom = rand(52) -1;
				}
				shuffledCards[sRandom][0] = deckofCards[i][0];
				shuffledCards[sRandom][1] = deckofCards[i][1];
			}
		}

		var displayPrint0 = false;
		if ( displayPrint0 ) {
			for ( i = 0; i < shuffledCards.length; i++ ) {
				print( i + " = " + shuffledCards[i][0] + shuffledCards[i][1] );
			}

			for ( i = 0; i < shuffledCards.length; i++ ) {
				sourcePic = ( cardPrefix + shuffledCards[i][0] + shuffledCards[i][1] + cardSuffix );
				print( "shuffledCards[" + i + "]=" + sourcePic );
			}
		}

		for ( i = 0; i < dealtHand.length; i++ ) {
			dealtHand[i] = new Array(2);
			dealtHand[i][0] = " ";
			dealtHand[i][1] = " ";
		}
		deal5Cards();
	} //end of shuffleDeck


	function deal5Cards(){
		if ( !card1Kept ) {
			dealCard1();
		}
		if ( !card2Kept ) {
			dealCard2();
		}
		if ( !card3Kept ) {
			dealCard3();
		}
		if ( !card4Kept ) {
			dealCard4();
		}
		if ( !card5Kept ) {
			dealCard5();
		}
	}//end of deal5Cards


	//fill first card slot on game table
	function dealCard1() {
		cardPic1.src = ( cardPrefix + shuffledCards[ cardIndex ][0] + shuffledCards[ cardIndex ][1] + cardSuffix );
		dealtHand[0][0] = shuffledCards[cardIndex][0];
		dealtHand[0][1] = shuffledCards[cardIndex][1];
		cardIndex++;
	}//end of dealCard1


	//fill second card slot on game table
	function dealCard2() {
		cardPic2.src = ( cardPrefix + shuffledCards[ cardIndex ][0] + shuffledCards[ cardIndex ][1] + cardSuffix );
		dealtHand[1][0] = shuffledCards[cardIndex][0];
		dealtHand[1][1] = shuffledCards[cardIndex][1];
		cardIndex++;
	}//end of dealCard2


	//fill thirs card slot on game table
	function dealCard3() {
		cardPic3.src = ( cardPrefix + shuffledCards[ cardIndex ][0] + shuffledCards[ cardIndex ][1] + cardSuffix );
		dealtHand[2][0] = shuffledCards[cardIndex][0];
		dealtHand[2][1] = shuffledCards[cardIndex][1];
		cardIndex++;
	}//end of dealCard3


	//fill fourth card slot on game table
	function dealCard4() {
		cardPic4.src = ( cardPrefix + shuffledCards[ cardIndex ][0] + shuffledCards[ cardIndex ][1] + cardSuffix );
		dealtHand[3][0] = shuffledCards[cardIndex][0];
		dealtHand[3][1] = shuffledCards[cardIndex][1];
		cardIndex++;
	}//end of dealCard4


	//fill fifth card slot on game table
	function dealCard5() {
		cardPic5.src = ( cardPrefix + shuffledCards[ cardIndex ][0] + shuffledCards[ cardIndex ][1] + cardSuffix );
		dealtHand[4][0] = shuffledCards[cardIndex][0];
		dealtHand[4][1] = shuffledCards[cardIndex][1];
		cardIndex++;
	}//end of dealCard5


	//keep the selected cards
	function keepCard1() {
		if ( drawTurn ) {
			if ( !card1Kept ) {
				holdCard1.data = "HOLD";
				card1Kept = true;
			}else{
				holdCard1.data = "";
				card1Kept = false;
			}
		}
	}
	function keepCard2() {
		if ( drawTurn ) {
			if ( !card2Kept ) {
				holdCard2.data = "HOLD";
				card2Kept = true;
			}else{
				holdCard2.data = "";
				card2Kept = false;
			}
		}
	}
	function keepCard3() {
		if ( drawTurn ) {
			if ( !card3Kept ) {
				holdCard3.data = "HOLD";
				card3Kept = true;
			}else{
				holdCard3.data = "";
				card3Kept = false;
			}
		}
	}
	function keepCard4() {
		if ( drawTurn ) {
			if ( !card4Kept ) {
				holdCard4.data = "HOLD";
				card4Kept = true;
			}else{
				holdCard4.data = "";
				card4Kept = false;
			}
		}
	}
	function keepCard5() {
		if ( drawTurn ) {
			if ( !card5Kept ) {
				holdCard5.data = "HOLD";
				card5Kept = true;
			}else{
				holdCard5.data = "";
				card5Kept = false;
			}
		}
	}


	//Call the routines that check to see if the current hand is a winner.
	function checkHand() {
		lastCard = cardIndex;
		firstCard = cardIndex - 5;
		countOccurs();

		checkRoyalFlush();
		if ( numRoyalFlush == 1 ) {
		  royalFlushWinner();
		}else{
		  checkStraightFlush();
		  if ( numStraightFlush == 1 ) {
		    straightFlushWinner();
		  }else{
		    checkFourofaKind();
		    if ( numFourofaKind == 1 ) {
			fourofaKindWinner();
		    }else{
			checkFullHouse();
			if ( numFullHouse == 1 ) {
			  fullHouseWinner();
			}else{
		        checkFlush();
		        if ( numFlush == 1 ) {
			    flushWinner();
			  }else{
		          checkStraight();
		          if ( numStraight == 1 ) {
			      straightWinner();
			    }else{
		            checkThreeofaKind();
		            if ( numThreeofaKind == 1 ) {
				  threeofaKindWinner();
			      }else{
		              checkPair();
		              if ( numPair == 2 ) {
				    twoPairWinner();
				  }else{
				    checkJacksorBetter();
		                if ( numPair == 1 ) {
		                  jacksorBetterWinner();
				    }
				    if ( numPair == 0 ) {
					noWinner();
				    }
				  }
				}
			    }
			  }
			}
		    }
		  }
		}

	}//end of checkHand


	//count how many occurrences of each card and suit there are
	function countOccurs() {
		numAce  = 0;
		numTwo  = 0;
		numThree  = 0;
		numFour  = 0;
		numFive  = 0;
		numSix  = 0;
		numSeven  = 0;
		numEight  = 0;
		numNine  = 0;
		numTen = 0;
		numJack  = 0;
		numQueen  = 0;
		numKing  = 0;

		numSpades   = 0;
		numHearts   = 0;
		numClubs    = 0;
		numDiamonds = 0;

		numPair          = 0;
		numTwoPair       = 0;
		numThreeofaKind  = 0;
		numFlush         = 0;
		numStraight      = 0
		numFullHouse     = 0;
		numFourofaKind   = 0;
		numStraightFlush = 0;
		numRoyalFlush    = 0;

		for ( i = 0; i < dealtHand.length; i++ ) {
			if ( dealtHand[i][0] == "A" )
				numAce++;
			if ( dealtHand[i][0] == "2" )
				numTwo++;
			if ( dealtHand[i][0] == "3" )
				numThree++;
			if ( dealtHand[i][0] == "4" )
				numFour++;
			if ( dealtHand[i][0] == "5" )
				numFive++;
			if ( dealtHand[i][0] == "6" )
				numSix++;
			if ( dealtHand[i][0] == "7" )
				numSeven++;
			if ( dealtHand[i][0] == "8" )
				numEight++;
			if ( dealtHand[i][0] == "9" )
				numNine++;
			if ( dealtHand[i][0] == "0" )
				numTen++;
			if ( dealtHand[i][0] == "J" )
				numJack++;
			if ( dealtHand[i][0] == "Q" )
				numQueen++;
			if ( dealtHand[i][0] == "K" )
				numKing++;

			if ( dealtHand[i][1] == "s" )
				numSpades++;
			if ( dealtHand[i][1] == "h" )
				numHearts++;
			if ( dealtHand[i][1] == "c" )
				numClubs++;
			if ( dealtHand[i][1] == "d" )
				numDiamonds++;
		}

		var displayPrint1 = false;
		if ( displayPrint1 ) {
			print( "A=" + numAce );
			print( "2=" + numTwo );
			print( "3=" + numThree );
			print( "4=" + numFour );
			print( "5=" + numFive );
			print( "6=" + numSix );
			print( "7=" + numSeven );
			print( "8=" + numEight );
			print( "9=" + numNine );
			print( "10=" + numTen );
			print( "J=" + numJack );
			print( "Q=" + numQueen );
			print( "K=" + numKing );
			print( "Spades=" + numSpades );
			print( "Hearts=" + numHearts );
			print( "Clubs=" + numClubs );
			print( "Diamonds=" + numDiamonds );
		}

	}//end of countOccurs


	function noWinner() {
		winnerLine.data = "No hand. Click Deal.";
	}


	function checkJacksorBetter() {
		numPair = 0;

		if ( numJack == 2 )
			numPair++;
		if ( numQueen == 2 )
			numPair++;
		if ( numKing == 2 )
			numPair++;
		if ( numAce == 2 )
			numPair++;
	}//end of checkJacksorBetter

	function jacksorBetterWinner() {
		winnerLine.data = "You got a Pair of Jacks or better!";
		gameScoreNumeric = gameScoreNumeric + 5;
		gameScore.data = gameScoreNumeric;
	}//end of jacksorBetterWinner


	function checkPair() {
		numPair = 0;

		if ( numAce == 2 )
			numPair++;
		if ( numTwo == 2 )
			numPair++;
		if ( numThree == 2 )
			numPair++;
		if ( numFour == 2 )
			numPair++;
		if ( numFive == 2 )
			numPair++;
		if ( numSix == 2 )
			numPair++;
		if ( numSeven == 2 )
			numPair++;
		if ( numEight == 2 )
			numPair++;
		if ( numNine == 2 )
			numPair++;
		if ( numTen == 2 )
			numPair++;
		if ( numJack == 2 )
			numPair++;
		if ( numQueen == 2 )
			numPair++;
		if ( numKing == 2 )
			numPair++;

//		print( "numPair=" + numPair );

	}//end of checkPair

	function twoPairWinner() {
		winnerLine.data = "You got Two Pair!";
		gameScoreNumeric = gameScoreNumeric + 10;
		gameScore.data = gameScoreNumeric;
	}//end of twoPairWinner


	function checkThreeofaKind() {

		numThreeofaKind = 0;

		if ( numAce == 3 )
			numThreeofaKind++;
		if ( numTwo == 3 )
			numThreeofaKind++;
		if ( numThree == 3 )
			numThreeofaKind++;
		if ( numFour == 3 )
			numThreeofaKind++;
		if ( numFive == 3 )
			numThreeofaKind++;
		if ( numSix == 3 )
			numThreeofaKind++;
		if ( numSeven == 3 )
			numThreeofaKind++;
		if ( numEight == 3 )
			numThreeofaKind++;
		if ( numNine == 3 )
			numThreeofaKind++;
		if ( numTen == 3 )
			numThreeofaKind++;
		if ( numJack == 3 )
			numThreeofaKind++;
		if ( numQueen == 3 )
			numThreeofaKind++;
		if ( numKing == 3 )
			numThreeofaKind++;

//		print( "numThreeofaKind=" + numThreeofaKind );

	}//end of checkThreeofaKind

	function threeofaKindWinner() {
		winnerLine.data = "You got Three of a Kind!"
		gameScoreNumeric = gameScoreNumeric + 15;
		gameScore.data = gameScoreNumeric;
	}//end of threeofaKindWinner


	function checkStraight() {
		numStraight = 0;

		//check for A2345
		if ( numAce == 1 ) {
		  if ( numTwo == 1 ) {
		    if ( numThree == 1 ) {
			if ( numFour == 1 ) {
			  if ( numFive == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }else{ //check for AKQJ0
		    if ( numKing == 1 ) {
			if ( numQueen == 1 ) {
			  if ( numJack == 1 ) {
			    if ( numTen == 1 ){
				numStraight++;
			    }
			  }
			}
		    }
		  }
		}

		//check for 23456
		if ( numTwo == 1 ) {
		  if ( numThree == 1 ) {
		    if ( numFour == 1  ) {
			if ( numFive == 1 ) {
			  if ( numSix == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 34567
		if ( numThree == 1 ) {
		  if ( numFour == 1 ) {
		    if ( numFive == 1 ) {
			if ( numSix == 1 ) {
			  if ( numSeven == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 45678
		if ( numFour == 1 ) {
		  if ( numFive == 1 ) {
		    if ( numSix == 1 ) {
			if ( numSeven == 1 ) {
			  if ( numEight == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 56789
		if ( numFive == 1 ) {
		  if ( numSix == 1 ) {
		    if ( numSeven == 1 ) {
			if ( numEight == 1 ) {
			  if ( numNine == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 67890
		if ( numSix == 1 ) {
		  if ( numSeven == 1 ) {
		    if ( numEight == 1 ) {
			if ( numNine == 1 ) {
			  if ( numTen == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 7890J
		if ( numSeven == 1 ) {
		  if ( numEight == 1 ) {
		    if ( numNine == 1 ) {
			if ( numTen == 1 ) {
			  if ( numJack == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 89OJQ
		if ( numEight == 1 ) {
		  if ( numNine == 1 ) {
		    if ( numTen == 1 ) {
			if ( numJack == 1 ) {
			  if ( numQueen == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

		//check for 90JQK
		if ( numNine == 1 ) {
		  if ( numTen == 1 ) {
		    if ( numJack == 1 ) {
			if ( numQueen == 1 ) {
			  if ( numKing == 1 ) {
			    numStraight++;
			  }
			}
		    }
		  }
		}

//		print( "numStraight=" + numStraight );

	}//end of checkStraight

	function straightWinner() {
		winnerLine.data = "You got a Straight!";
		gameScoreNumeric = gameScoreNumeric + 20;
		gameScore.data = gameScoreNumeric;
	}//end of straightWinner


	function checkFlush() {

		numFlush = 0;

		if ( numSpades == 5 )
			numFlush++;
		if ( numHearts == 5 )
			numFlush++;
		if ( numClubs == 5 )
			numFlush++;
		if ( numDiamonds == 5 )
			numFlush++;

//		print( "numFlush=" + numFlush );

	}//end of checkFlush

	function flushWinner() {
		winnerLine.data = "You got a Flush!";
		displayLine.data = "Deal";
		gameScoreNumeric = gameScoreNumeric + 25;
		gameScore.data = gameScoreNumeric;
	}//end of flushWinner


	function checkFullHouse() {
		checkThreeofaKind();
		if ( numThreeofaKind == 1 ) {
		  checkPair();
		  if ( numPair == 1 ) {
		    numFullHouse++;
		  }
		}

//		print( "numFullHouse=" + numFullHouse + " numThreeofaKind=" + numThreeofaKind + " numPair=" + numPair );

	}//end of checkFullHouse

	function fullHouseWinner() {
		winnerLine.data = "You got a Full House!";
		displayLine.data = "Deal";
		gameScoreNumeric = gameScoreNumeric + 40;
		gameScore.data = gameScoreNumeric;
	}//end of fullHouseWinner


	function checkFourofaKind() {
		if ( numAce == 4 )
			numFourofaKind++;
		if ( numTwo == 4 )
			numFourofaKind++;
		if ( numThree == 4 )
			numFourofaKind++;
		if ( numFour == 4 )
			numFourofaKind++;
		if ( numFive == 4 )
			numFourofaKind++;
		if ( numSix == 4 )
			numFourofaKind++;
		if ( numSeven == 4 )
			numFourofaKind++;
		if ( numEight == 4 )
			numFourofaKind++;
		if ( numNine == 4 )
			numFourofaKind++;
		if ( numTen == 4 )
			numFourofaKind++;
		if ( numJack == 4 )
			numFourofaKind++;
		if ( numQueen == 4 )
			numFourofaKind++;
		if ( numKing == 4 )
			numFourofaKind++;

//		print( "numFourofaKind=" + numFourofaKind );

	}//end of checkFourofaKind

	function fourofaKindWinner() {
		winnerLine.data = "You got Four of a Kind!"
		displayLine.data = "Deal";
		gameScoreNumeric = gameScoreNumeric + 125;
		gameScore.data = gameScoreNumeric;
	}//end of fourofaKindWinner


	function checkStraightFlush() {
		checkFlush();
		if ( numFlush == 1 ) {
		  checkStraight();
		  if ( numStraight == 1 ) {
		    numStraightFlush++;
		  }
		}

//		print( "numStraightFlush=" + numStraightFlush );

	}//end of checkStraightFlush

	function straightFlushWinner() {
		winnerLine.data = "You got a Straight Flush!";
		displayLine.data = "Deal";
		gameScoreNumeric = gameScoreNumeric + 200;
		gameScore.data = gameScoreNumeric;
	}//end of straightFlushWinner


	function checkRoyalFlush() {
		//check for Spades
		if ( cardPic1.src == aceOfSpades || cardPic1.src == kingOfSpades || cardPic1.src == queenOfSpades ||
		     cardPic1.src == jackOfSpades || cardPic1.src == tenOfSpades ) {
			if ( cardPic2.src == aceOfSpades || cardPic2.src == kingOfSpades || cardPic2.src == queenOfSpades ||
			     cardPic2.src == jackOfSpades || cardPic2.src == tenOfSpades ) {
				if ( cardPic3.src == aceOfSpades || cardPic3.src == kingOfSpades || cardPic3.src == queenOfSpades ||
				     cardPic3.src == jackOfSpades || cardPic3.src == tenOfSpades ) {
					if ( cardPic4.src == aceOfSpades || cardPic4.src == kingOfSpades || cardPic4.src == queenOfSpades ||
					     cardPic4.src == jackOfSpades || cardPic4.src == tenOfSpades ) {
						if ( cardPic5.src == aceOfSpades || cardPic5.src == kingOfSpades || cardPic5.src == queenOfSpades ||
						     cardPic5.src == jackOfSpades || cardPic5.src == tenOfSpades ) {
							numRoyalFlush++;
						}
					}
				}
			}
		}//end of Spades check


		//check for Hearts
		if ( cardPic1.src == aceOfHearts || cardPic1.src == kingOfHearts || cardPic1.src == queenOfHearts ||
		     cardPic1.src == jackOfHearts || cardPic1.src == tenOfHearts ) {
			if ( cardPic2.src == aceOfHearts || cardPic2.src == kingOfHearts || cardPic2.src == queenOfHearts ||
			     cardPic2.src == jackOfHearts || cardPic2.src == tenOfHearts ) {
				if ( cardPic3.src == aceOfHearts || cardPic3.src == kingOfHearts || cardPic3.src == queenOfHearts ||
				     cardPic3.src == jackOfHearts || cardPic3.src == tenOfHearts ) {
					if ( cardPic4.src == aceOfHearts || cardPic4.src == kingOfHearts || cardPic4.src == queenOfHearts ||
					     cardPic4.src == jackOfHearts || cardPic4.src == tenOfHearts ) {
						if ( cardPic5.src == aceOfHearts || cardPic5.src == kingOfHearts || cardPic5.src == queenOfHearts ||
						     cardPic5.src == jackOfHearts || cardPic5.src == tenOfHearts ) {
							numRoyalFlush++;
						}
					}
				}
			}
		}//end of Hearts check


		//check for Clubs
		if ( cardPic1.src == aceOfClubs || cardPic1.src == kingOfClubs || cardPic1.src == queenOfClubs ||
		     cardPic1.src == jackOfClubs || cardPic1.src == tenOfClubs ) {
			if ( cardPic2.src == aceOfClubs || cardPic2.src == kingOfClubs || cardPic2.src == queenOfClubs ||
			     cardPic2.src == jackOfClubs || cardPic2.src == tenOfClubs ) {
				if ( cardPic3.src == aceOfClubs || cardPic3.src == kingOfClubs || cardPic3.src == queenOfClubs ||
				     cardPic3.src == jackOfClubs || cardPic3.src == tenOfClubs ) {
					if ( cardPic4.src == aceOfClubs || cardPic4.src == kingOfClubs || cardPic4.src == queenOfClubs ||
					     cardPic4.src == jackOfClubs || cardPic4.src == tenOfClubs ) {
						if ( cardPic5.src == aceOfClubs || cardPic5.src == kingOfClubs || cardPic5.src == queenOfClubs ||
						     cardPic5.src == jackOfClubs || cardPic5.src == tenOfClubs ) {
							numRoyalFlush++;
						}
					}
				}
			}
		}//end of Clubs check


		//check for Diamonds
		if ( cardPic1.src == aceOfDiamonds || cardPic1.src == kingOfDiamonds || cardPic1.src == queenOfDiamonds ||
		     cardPic1.src == jackOfDiamonds || cardPic1.src == tenOfDiamonds ) {
			if ( cardPic2.src == aceOfDiamonds || cardPic2.src == kingOfDiamonds || cardPic2.src == queenOfDiamonds ||
			     cardPic2.src == jackOfDiamonds || cardPic2.src == tenOfDiamonds ) {
				if ( cardPic3.src == aceOfDiamonds || cardPic3.src == kingOfDiamonds || cardPic3.src == queenOfDiamonds ||
				     cardPic3.src == jackOfDiamonds || cardPic3.src == tenOfDiamonds ) {
					if ( cardPic4.src == aceOfDiamonds || cardPic4.src == kingOfDiamonds || cardPic4.src == queenOfDiamonds ||
					     cardPic4.src == jackOfDiamonds || cardPic4.src == tenOfDiamonds ) {
						if ( cardPic5.src == aceOfDiamonds || cardPic5.src == kingOfDiamonds || cardPic5.src == queenOfDiamonds ||
						     cardPic5.src == jackOfDiamonds || cardPic5.src == tenOfDiamonds ) {
							numRoyalFlush++;
						}
					}
				}
			}
		}//end of Clubs check

//		print( "numRoyalFlush=" + numRoyalFlush );

	}//end of checkRoyalFlush

	function royalFlushWinner() {
		winnerLine.data = "You got a Royal Flush!";
		displayLine.data = "Deal";
		gameScoreNumeric = gameScoreNumeric + 2000;
		gameScore.data = gameScoreNumeric;
	}//end of royalFlushWinner








	//routine to calculate how many deals it would take to
	//be dealt a Royal Flush of any suit
	function royalFlushCount() {
		var dealCount = 0;
		var numberOfTrys = 0;
		while (!royalFlushDealt) {
			numberOfTrys++;
			initializeDeck();
			shuffleDeck();
			for ( i = 0; i < 10; i++ ) {
				if ( !royalFlushDealt ) {
					dealCount++;
					deal5Cards();
					checkRoyalFlushDealt();
				}
			}
		}

		print( "Royal Flush dealt naturally in " + dealCount + " trys." );

	}//end of royalFlushCount